/*

                                   _JNJ`                        
                               .JNMH`                           
                              JMMF`       `;.                   
                            .NMM)          `MN.                 
                            MMM)            (MML                
                           (MMM`             MMML               
                     M  I  D  N  I  G  H  T    C  o  D  E       
                           (NMMF             MHNH               
                            NMML            .MMM                
                             NMML          .NMH                 
                              4MMNL       .#F                   
                               `4HNNL_   `                      
                                   `"""`                        

                          Copyright (C) 2004-2006
       "Ian (Larry) Latter" <ian dot latter at midnightcode dot org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, and mirrored at the Midnight Code web
    site; as at version 2 of the License only.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.
  
    You should have received a copy of the GNU General Public License
    (version 2) along with this program; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA, or see http://midnightcode.org/gplv2.txt

*/


/* midnightcode-html.h :: Midnight Code HTML library			*/


#ifndef __MIDNIGHTCODE_HTML_H
#define __MIDNIGHTCODE_HTML_H


#define MIDNIGHTCODE_HTML_TEXT_TAG "midnightcode_text"

enum midnightcode_html_url_type_t
{
  MIDNIGHTCODE_HTML_URL_TYPE_UNKNOWN = 0,
  MIDNIGHTCODE_HTML_URL_TYPE_RELATIVE = 1,
  MIDNIGHTCODE_HTML_URL_TYPE_ABSOLUTE = 2,
  MIDNIGHTCODE_HTML_URL_TYPE_FULL = 3,
  MIDNIGHTCODE_HTML_URL_TYPE_URI = 4
};

struct midnightcode_html_tag_element_t
{
  char * option;
  char * value;
  midnightcode_list_entry(midnightcode_html_tag_element_t)
};

midnightcode_list_head(midnightcode_html_tag_head_t,
                       midnightcode_html_tag_element_t)

struct midnightcode_html_document_element_t
{
  struct midnightcode_html_tag_head_t * tag;
  midnightcode_list_entry(midnightcode_html_document_element_t)
};

midnightcode_list_head(midnightcode_html_document_head_t,
                       midnightcode_html_document_element_t)

int midnightcode_html_urltype(char *parse_buf, int parse_len);
int midnightcode_html_urlbase(char *string_dst, char *parse_src, int parse_len,
                       int for_type);
int midnightcode_html_tagbit(char * parse_src, char * store_src,
                       int tag_state, int equal_state,
                       struct midnightcode_html_tag_element_t ** tag_element,
                       struct midnightcode_html_tag_head_t * tag,
                       struct midnightcode_html_document_head_t * document);
int midnightcode_html_parse(char *parse_buf, int parse_len,
                       struct midnightcode_html_document_head_t * document);

#endif
